package com.bergerkiller.bukkit.sl.API;

import org.bukkit.Bukkit;

public class GroupVariable {
	
	private PlayerVariable[] players;
	private Variable variable;
	private String value;
	private Ticker ticker;
	
	public GroupVariable(PlayerVariable[] players, Variable variable) {
		this(players, variable, variable.getDefault());
	}
	public GroupVariable(PlayerVariable[] players, Variable variable, String value) {
		this.players = players;
		this.variable = variable;
		this.value = value;
	}

	public String get() {
		return this.value;
	}
	public PlayerVariable[] getPlayers() {
		return this.players;
	}
	public String[] getPlayerNames() {
		String[] rval = new String[this.players.length];
		for (int i = 0; i < rval.length; i++) {
			rval[i] = this.players[i].getPlayer();
		}
		return rval;
	}
			
	public boolean set(String value) {
		VariableChangeEvent event = new VariableChangeEvent(this.variable, value, this.players, VariableChangeType.PLAYER);
		Bukkit.getServer().getPluginManager().callEvent(event);
		if (!event.isCancelled()) {
			this.value = value;
			if (this.ticker != null) {
				this.ticker.reset(value);
			}
			for (PlayerVariable pvar : this.players) {
				if (this.ticker == null) {
					pvar.ticker.reset(value);
				}
				pvar.value = value;
			}
			this.variable.setSigns(value, false, getPlayerNames());
			return true;
		} else {
			return false;
		}
	}

	public Variable getVariable() {
		return this.variable;
	}
	
	public void clear() {
		this.set("%" + this.variable.getName() + "%");
		this.ticker = null;
	}
	
	public Ticker getTicker() {
		if (this.ticker == null) {
			this.ticker = new Ticker(this.value, this.getPlayerNames());
			for (PlayerVariable pvar : this.players) {
				pvar.ticker = this.ticker;
			}
		}
		return this.ticker;
	}
	
}
